// ==UserScript==
// @name           GC Search geocache list
// @namespace      http://localhost
// @description    Pridanie zoznamu do search stranky a ikonky do mapy pre prepnutie na search stranku
// @include        https://www.geocaching.com/play/search*
// @include        https://www.geocaching.com/map*
// @version        0.0.1
// ==/UserScript==

var p_searchPageUrl = "https://www.geocaching.com/play/search/"; //url search stranky

var scrollIndex = 40;
var scrollIndexMaxValue = 40;
var zoznamKesiek = [];
var vzdialenostPoslednejKesky = [];

var url = "" + window.location;


function caesar_searchPageScrollAction(){

	//ziskanie vsetkych gc kodov z tabulky
	var keskyElementTmp = document.getElementsByClassName("cache-details"); //vysledok je v tvare Upside Down / Dole hlavou
	var keskaSplitTmp;
	for (var i = 0; i < keskyElementTmp.length;i++){
		keskaSplitTmp = keskyElementTmp[i].textContent.split(" | ");
		if (zoznamKesiek.indexOf(keskaSplitTmp[1].trim()) == -1){
			zoznamKesiek.push(keskaSplitTmp[1].trim());
		}
		
	}
	
	//ziskanie vzdialenosti poslednej kesky
	keskyElementTmp = document.getElementsByClassName("pri-6"); //vrati nam " 1.3km NW "
	var poslednaVzdialenostElementTmp = keskyElementTmp[keskyElementTmp.length-1].textContent.trim(); //rozsekame, medzi vzdialenostou a smerom je vela medzier, to ale neriesime, potrebujeme len prve cislo
	poslednaVzdialenostElementTmp = poslednaVzdialenostElementTmp.split(" ");
	vzdialenostPoslednejKesky = poslednaVzdialenostElementTmp[0];
	
	

	if (!document.getElementById('caesar1987_cachelistDiv')){
		var elem = document.body;
			if (elem){
				//vytvorenie divu pre vkladanie informacii ak neexistuje
				var cachelistDiv = document.createElement("div");
				cachelistDiv.setAttribute('id','caesar1987_cachelistDiv');
				cachelistDiv.style.position = "fixed";
				cachelistDiv.style.width = "150px";
				cachelistDiv.style.height = "90%";
				cachelistDiv.style.top = "50px";
				cachelistDiv.style.right = "5px";
				cachelistDiv.style.fontSize = "11px";
				cachelistDiv.style.overflow = "scroll";
				cachelistDiv.style.backgroundColor="#FFFFCC";
				cachelistDiv.style.padding = "5px";
				elem.appendChild(cachelistDiv);
				
		}
	}
	
	
	var elem2 = document.getElementById('caesar1987_cachelistDiv');
	elem2.innerHTML = "";
	//vytvorenie buttonu ktory generuje subor
	var novybutton = document.createElement("input");
	novybutton.setAttribute('type','button');
	novybutton.setAttribute('value','Stiahnuť');
	//pridanie listenera na stlacenie buttonu
	novybutton.addEventListener('click', function(){
	
		caesar_vytvorSuborSoZoznamom();

	}, false);
	
	elem2.appendChild(novybutton);
	elem2.appendChild(document.createElement("br"));
	elem2.appendChild(document.createTextNode("Počet: " + keskyElementTmp.length));
	elem2.appendChild(document.createElement("br"));
	elem2.appendChild(document.createTextNode("Posledna: " + vzdialenostPoslednejKesky));
	elem2.appendChild(document.createElement("br"));
	elem2.appendChild(document.createTextNode("--------------------"));
	elem2.appendChild(document.createElement("br"));
	
	//vypisanie zoznamu gckodov
	for (var i = 0; i < zoznamKesiek.length;i++){
		elem2.appendChild(document.createTextNode(zoznamKesiek[i]));
		elem2.appendChild(document.createElement("br"));
	}
	//var zoznamString = zoznamKesiek.join("\n");
	//elem2.appendChild(document.createTextNode(zoznamString));
			
}

function caesar_vytvorSuborSoZoznamom(){ 
	obsah = zoznamKesiek.join("\r\n");
	caesar_vytvorSuborNaStiahnutie(obsah,"ZoznamKesiek");
}

function caesar_vytvorSuborNaStiahnutie(obsah,nazov){
	//vytvorenie pomocneho odkazu pre to, aby sme mohli dat suboru nazov a priponu. Bez neho to aktualne fo firefoxe nejde.
	var pomocnyOdkaz = document.createElement('a');
    pomocnyOdkaz.setAttribute('href', 'data:text/gpx;charset=utf-8,' + encodeURIComponent(obsah));
    pomocnyOdkaz.setAttribute('download', nazov+".txt");
	pomocnyOdkaz.setAttribute('id', "caesar_pomocnyOdkaz");
	
	//pomocny odkaz umiestnime na stranku
	var element2 = document.body;
	element2.appendChild(pomocnyOdkaz);
	
	//klikneme na odkaz
	var theEvent = document.createEvent("MouseEvent");
	theEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
	var element = document.getElementById('caesar_pomocnyOdkaz');
	element.dispatchEvent(theEvent);
	
	//vymazeme odkaz
	element.parentNode.removeChild(element);

}

function caesar_presmerujNaVyhladavanie(){

	//ziskanie parametrov z url, upraveny kod z
	//http://stackoverflow.com/questions/5448545/how-to-retrieve-get-parameters-from-javascript/21210643#21210643
	var queryDict = {};
	window.location.hash.substr(2).split("&").forEach(function(item) {queryDict[item.split("=")[0]] = item.split("=")[1]});
	var vykladanaUrl = p_searchPageUrl + "@" + queryDict.ll + "?origin="+ queryDict.ll +"&radius=50km";
	
	var pomocnyOdkaz = document.createElement('a');
    pomocnyOdkaz.setAttribute('href', vykladanaUrl);
	pomocnyOdkaz.setAttribute('id', "caesar_pomocnyOdkaz2");
	pomocnyOdkaz.setAttribute('target', "_blank");
	var element2 = document.body;
	element2.appendChild(pomocnyOdkaz);
	
	//klikneme na odkaz
	var theEvent = document.createEvent("MouseEvent");
	theEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
	var element = document.getElementById('caesar_pomocnyOdkaz2');
	element.dispatchEvent(theEvent);
	
	//vymazeme odkaz
	element.parentNode.removeChild(element);
}

function mapPageAddLink(){ //pridanie odkazu na mapu pre otvorenie vyhladavania so suradnicami centra mapy (suradnice su v url stranky)
	var elem = document.getElementsByClassName("LogIn")[0];
	if (elem){
	
		var novyodkazImg = document.createElement("img");
		novyodkazImg.setAttribute("src","/images/icons/search.png");
		novyodkazImg.setAttribute("id","caesar_mapaSearchImage");
		novyodkazImg.style.marginTop = "12px";
		novyodkazImg.style.marginRight = "5px";
	
		var novyodkaz = document.createElement("a");
		novyodkaz.appendChild(novyodkazImg);
		novyodkaz.appendChild(document.createTextNode('Otvoriť vyhľadávanie'));
		novyodkaz.setAttribute("id","caesar_mapaSearch");
		novyodkaz.style.paddingRight = "20px";
		novyodkaz.style.cursor = "pointer";
		
		//pridanie listenera na stlacenie buttonu
		novyodkaz.addEventListener('click', function(){
		
			caesar_presmerujNaVyhladavanie();

		}, false);
	
	elem.insertBefore(novyodkaz, elem.firstChild);
	
	}
}


/* scrollIndex */
function scrollIndexAdd(){
	scrollIndex++;
}
function returnScrollIndex(){
	return scrollIndex;
}

function scrollIndexReset(){
	scrollIndex = 0;
}


if (url.indexOf("play/search") != -1){ //otvorena search stranka

	window.addEventListener("scroll",  function () { 
							scrollIndexAdd();
							if (returnScrollIndex() >= scrollIndexMaxValue){
								setTimeout(function() {caesar_searchPageScrollAction();}, 0);
								scrollIndexReset();
								}
						}, false);
}else if (url.indexOf("map/") != -1){ //otvorena mapa
	mapPageAddLink();
}